﻿
///////////////////////////////////////////////////
//Служебные функции и процедуры
///////////////////////////////////////////////////

&НаКлиенте
// контекст фреймворка Vanessa-Behavior
Перем Ванесса;
 
&НаКлиенте
// Структура, в которой хранится состояние сценария между выполнением шагов. Очищается перед выполнением каждого сценария.
Перем Контекст Экспорт;
 
&НаКлиенте
// Структура, в которой можно хранить служебные данные между запусками сценариев. Существует, пока открыта форма Vanessa-Behavior.
Перем КонтекстСохраняемый Экспорт;

&НаКлиенте
// Функция экспортирует список шагов, которые реализованы в данной внешней обработке.
Функция ПолучитьСписокТестов(КонтекстФреймворкаBDD) Экспорт
	Ванесса = КонтекстФреймворкаBDD;
	
	ВсеТесты = Новый Массив;

	//описание параметров
	//Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,Снипет,ИмяПроцедуры,ПредставлениеТеста,ОписаниеШага,ТипШага,Транзакция,Параметр);

	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ЯОстанавливаюВыполнениеШаговВсехСценариев()","ЯОстанавливаюВыполнениеШаговВсехСценариев","Затем я останавливаю выполнение шагов всех сценариев.","Останавливает выполнение шагов. Другие сценарии выполнятся не будут.","Прочее.Остановить выполнение сценариев");
	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ЯОстанавливаюВыполнениеСценария()","ЯОстанавливаюВыполнениеСценария","Затем я останавливаю выполнение сценария","Останавливает выполнение шагов в данном сценарии.","Прочее.Остановить выполнение сценариев");

	Возврат ВсеТесты;
КонецФункции
	
&НаСервере
// Служебная функция.
Функция ПолучитьМакетСервер(ИмяМакета)
	ОбъектСервер = РеквизитФормыВЗначение("Объект");
	Возврат ОбъектСервер.ПолучитьМакет(ИмяМакета);
КонецФункции
	
&НаКлиенте
// Служебная функция для подключения библиотеки создания fixtures.
Функция ПолучитьМакетОбработки(ИмяМакета) Экспорт
	Возврат ПолучитьМакетСервер(ИмяМакета);
КонецФункции



///////////////////////////////////////////////////
//Работа со сценариями
///////////////////////////////////////////////////

&НаКлиенте
// Процедура выполняется перед началом каждого сценария
Процедура ПередНачаломСценария() Экспорт
	
КонецПроцедуры

&НаКлиенте
// Процедура выполняется перед окончанием каждого сценария
Процедура ПередОкончаниемСценария() Экспорт
	
КонецПроцедуры



///////////////////////////////////////////////////
//Реализация шагов
///////////////////////////////////////////////////

&НаКлиенте
//Затем я останавливаю выполнение шагов
//@ЯОстанавливаюВыполнениеШагов()
Процедура ЯОстанавливаюВыполнениеШаговВсехСценариев() Экспорт
	Ванесса.УстановитьФлагОстановкиВыполненияШаговВсехСценариев();
КонецПроцедуры

&НаКлиенте
//Затем я останавливаю выполнение сценария
//@ЯОстанавливаюВыполнениеСценария()
Процедура ЯОстанавливаюВыполнениеСценария() Экспорт
	Ванесса.УстановитьФлагОстановкиВыполненияШаговОдногоСценария();
КонецПроцедуры
