﻿//начало текста модуля

///////////////////////////////////////////////////
//Служебная часть
///////////////////////////////////////////////////


// контекст фреймворка Vanessa-Behavior
Перем Ванесса;
 


// Служебная функция.
Функция ДобавитьШагВМассивТестов(МассивТестов,Снипет,ИмяПроцедуры,ПредставлениеТеста = Неопределено,Транзакция = Неопределено,Параметр = Неопределено)
	Структура = Новый Структура;
	Структура.Вставить("Снипет",Снипет);
	Структура.Вставить("ИмяПроцедуры",ИмяПроцедуры);
	Структура.Вставить("ИмяПроцедуры",ИмяПроцедуры);
	Структура.Вставить("ПредставлениеТеста",ПредставлениеТеста);
	Структура.Вставить("Транзакция",Транзакция);
	Структура.Вставить("Параметр",Параметр);
	МассивТестов.Добавить(Структура);
КонецФункции


// Функция экспортирует список шагов, которые реализованы в данной внешней обработке.
Функция ПолучитьСписокТестов(КонтекстФреймворкаBDD) Экспорт
	Ванесса = КонтекстФреймворкаBDD;
	
	ВсеТесты = Новый Массив;

	//описание параметров
	//ДобавитьШагВМассивТестов(ВсеТесты,Снипет,ИмяПроцедуры,ПредставлениеТеста,Транзакция,Параметр);

	ДобавитьШагВМассивТестов(ВсеТесты,"ВДеревеЗагруженнойФичиБудетГруппа(Парам01)","ВДеревеЗагруженнойФичиБудетГруппа","Тогда в дереве загруженной фичи будет группа ""ПерваяГруппа""");
	ДобавитьШагВМассивТестов(ВсеТесты,"ВДеревеЗагруженнойФичиВнутриГруппыБудетГруппа(Парам01,Парам02)","ВДеревеЗагруженнойФичиВнутриГруппыБудетГруппа","И     в дереве загруженной фичи внутри группы ""ПерваяГруппа"" будет группа ""ТретьяГруппа""");
	ДобавитьШагВМассивТестов(ВсеТесты,"ВДеревеЗагруженнойФичиШагБудетВнутриГруппы(Парам01,Парам02)","ВДеревеЗагруженнойФичиШагБудетВнутриГруппы","И     в дереве загруженной фичи шаг ""Первый шаг фичи Проверка работы областей в дереве"" будет внутри группы ""ПерваяГруппа""");

	Возврат ВсеТесты;
КонецФункции
	

// Служебная функция.
Функция ПолучитьМакетСервер(ИмяМакета)
	Возврат ПолучитьМакет(ИмяМакета);
КонецФункции
	

// Служебная функция для подключения библиотеки создания fixtures.
Функция ПолучитьМакетОбработки(ИмяМакета) Экспорт
	Возврат ПолучитьМакетСервер(ИмяМакета);
КонецФункции



///////////////////////////////////////////////////
//Работа со сценариями
///////////////////////////////////////////////////


// Процедура выполняется перед началом каждого сценария
Процедура ПередНачаломСценария() Экспорт
	
КонецПроцедуры


// Процедура выполняется перед окончанием каждого сценария
Процедура ПередОкончаниемСценария() Экспорт
	//безусловное закрытие формы если она осталась
	Попытка
	    ОткрытаяФормаVanessaBehavoir = Контекст.ОткрытаяФормаVanessaBehavoir;
		ОткрытаяФормаVanessaBehavoir.Закрыть();
	Исключение
	
	КонецПопытки;
КонецПроцедуры



///////////////////////////////////////////////////
//Реализация шагов
///////////////////////////////////////////////////


Процедура НайтиЭлементВДереве(ДеревоСтроки,ИмяОбласти,ЕстьЭлемент)
	Если ЕстьЭлемент Тогда
		Возврат;
	КонецЕсли;	 
	
	Для каждого СтрокаДерева Из ДеревоСтроки Цикл
		Если СтрокаДерева.Имя = ИмяОбласти Тогда
			ЕстьЭлемент = Истина;
			Возврат;
		КонецЕсли;	 
		
		НайтиЭлементВДереве(СтрокаДерева.Строки,ИмяОбласти,ЕстьЭлемент);
	КонецЦикла;
КонецПроцедуры

//Тогда в дереве загруженной фичи будет группа "ПерваяГруппа"
//@ВДеревеЗагруженнойФичиБудетГруппа(Парам01)
Процедура ВДеревеЗагруженнойФичиБудетГруппа(ИмяОбласти) Экспорт
	ДеревоТестов = Контекст.ОткрытаяФормаVanessaBehavoir.ДеревоТестов;
	
	ЕстьЭлемент = Ложь;
	НайтиЭлементВДереве(ДеревоТестов.СТроки,ИмяОбласти,ЕстьЭлемент);
	Ванесса.ПроверитьРавенство(ЕстьЭлемент,Истина,"Нашли в дереве область " + ИмяОбласти);
КонецПроцедуры


Процедура НайтиСтрокуДереваПоИмени(ДеревоСтроки,ИмяОбласти,ИскомаяСтрока);
	Если ИскомаяСтрока <> Неопределено Тогда
		Возврат;
	КонецЕсли;	 
	
	Для каждого СтрокаДерева Из ДеревоСтроки Цикл
		Если СтрокаДерева.Имя = ИмяОбласти Тогда
			ИскомаяСтрока = СтрокаДерева;
			Возврат;
		КонецЕсли;	 
		
		НайтиСтрокуДереваПоИмени(СтрокаДерева.Строки,ИмяОбласти,ИскомаяСтрока);
	КонецЦикла;
КонецПроцедуры

//И     в дереве загруженной фичи внутри группы "ПерваяГруппа" будет группа "ТретьяГруппа"
//@ВДеревеЗагруженнойФичиВнутриГруппыБудетГруппа(Парам01,Парам02)
Процедура ВДеревеЗагруженнойФичиВнутриГруппыБудетГруппа(ИмяОбласти1,ИмяОбласти2) Экспорт
	ДеревоТестов = Контекст.ОткрытаяФормаVanessaBehavoir.ДеревоТестов;
	
	ИскомаяСтрока = Неопределено;
	НайтиСтрокуДереваПоИмени(ДеревоТестов.СТроки,ИмяОбласти2,ИскомаяСтрока);
	Ванесса.ПроверитьНеРавенство(ИскомаяСтрока,Неопределено,"Нашли в дереве область " + ИмяОбласти2);
	
	Ванесса.ПроверитьРавенство(ИскомаяСтрока.Родитель.Имя,ИмяОбласти1,"" + ИмяОбласти2 + " находится внутри " + ИмяОбласти1);
КонецПроцедуры


//И     в дереве загруженной фичи шаг "Первый шаг фичи Проверка работы областей в дереве" будет внутри группы "ПерваяГруппа"
//@ВДеревеЗагруженнойФичиШагБудетВнутриГруппы(Парам01,Парам02)
Процедура ВДеревеЗагруженнойФичиШагБудетВнутриГруппы(Строка1,Строка2) Экспорт
	ДеревоТестов = Контекст.ОткрытаяФормаVanessaBehavoir.ДеревоТестов;
	
	ИскомаяСтрока = Неопределено;
	НайтиСтрокуДереваПоИмени(ДеревоТестов.СТроки,Строка1,ИскомаяСтрока);
	Ванесса.ПроверитьНеРавенство(ИскомаяСтрока,Неопределено,"Нашли в дереве область <" + Строка1 + ">");
	
	Ванесса.ПроверитьРавенство(ИскомаяСтрока.Родитель.Имя,Строка2,"" + Строка1 + " находится внутри " + Строка2);
КонецПроцедуры

//окончание текста модуля  