﻿
///////////////////////////////////////////////////
//Служебные функции и процедуры
///////////////////////////////////////////////////

&НаКлиенте
// контекст фреймворка Vanessa-Behavior
Перем Ванесса;
 
&НаКлиенте
// Структура, в которой хранится состояние сценария между выполнением шагов. Очищается перед выполнением каждого сценария.
Перем Контекст Экспорт;
 
&НаКлиенте
// Структура, в которой можно хранить служебные данные между запусками сценариев. Существует, пока открыта форма Vanessa-Behavior.
Перем КонтекстСохраняемый Экспорт;

&НаКлиенте
// Функция экспортирует список шагов, которые реализованы в данной внешней обработке.
Функция ПолучитьСписокТестов(КонтекстФреймворкаBDD) Экспорт
	Ванесса = КонтекстФреймворкаBDD;
	
	ВсеТесты = Новый Массив;

	//описание параметров
	//Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,Снипет,ИмяПроцедуры,ПредставлениеТеста,ОписаниеШага,ТипШага,Транзакция,Параметр);

	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ЯСохранилВКонтекстеСИспользованиемСохранитьЗначениеВКонтекстЗначениеСКлючом(Парам01,Парам02)","ЯСохранилВКонтекстеСИспользованиемСохранитьЗначениеВКонтекстЗначениеСКлючом","Когда я сохранил в контексте с использованием СохранитьЗначениеВКонтекст значение 1 с ключом ""тест""","","");
	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ФункцияФреймворкаПолучитьСохраненноеЗначениеИзКонтекстаСПараметромВозвращает(Парам01,Парам02)","ФункцияФреймворкаПолучитьСохраненноеЗначениеИзКонтекстаСПараметромВозвращает","Тогда функция фреймворка ПолучитьСохраненноеЗначениеИзКонтекста с параметром ""тест"" возвращает 1","","");
	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ФункцияФреймворкаПолучитьЗначениеИзКонтекстаЕслиЭтоВозможноСПараметромВозвращает(Парам01,Парам02)","ФункцияФреймворкаПолучитьЗначениеИзКонтекстаЕслиЭтоВозможноСПараметромВозвращает","И функция фреймворка ПолучитьЗначениеИзКонтекстаЕслиЭтоВозможно с параметром ""$тест$"" возвращает 1","","");

	Возврат ВсеТесты;
КонецФункции
	
&НаСервере
// Служебная функция.
Функция ПолучитьМакетСервер(ИмяМакета)
	ОбъектСервер = РеквизитФормыВЗначение("Объект");
	Возврат ОбъектСервер.ПолучитьМакет(ИмяМакета);
КонецФункции
	
&НаКлиенте
// Служебная функция для подключения библиотеки создания fixtures.
Функция ПолучитьМакетОбработки(ИмяМакета) Экспорт
	Возврат ПолучитьМакетСервер(ИмяМакета);
КонецФункции



///////////////////////////////////////////////////
//Работа со сценариями
///////////////////////////////////////////////////

&НаКлиенте
// Процедура выполняется перед началом каждого сценария
Процедура ПередНачаломСценария() Экспорт
	
КонецПроцедуры

&НаКлиенте
// Процедура выполняется перед окончанием каждого сценария
Процедура ПередОкончаниемСценария() Экспорт
	
КонецПроцедуры



///////////////////////////////////////////////////
//Реализация шагов
///////////////////////////////////////////////////

&НаКлиенте
//Когда я сохранил в контексте с использованием СохранитьЗначениеВКонтекст значение 1 с ключом "тест"
//@ЯСохранилВКонтекстеСИспользованиемСохранитьЗначениеВКонтекстЗначениеСКлючом(Парам01,Парам02)
Процедура ЯСохранилВКонтекстеСИспользованиемСохранитьЗначениеВКонтекстЗначениеСКлючом(Парам01,Парам02) Экспорт
    Ванесса.СохранитьЗначениеВКонтекст(Парам02, Парам01);
КонецПроцедуры

&НаКлиенте
//Тогда функция фреймворка ПолучитьСохраненноеЗначениеИзКонтекста с параметром "тест" возвращает 1
//@ФункцияФреймворкаПолучитьСохраненноеЗначениеИзКонтекстаСПараметромВозвращает(Парам01,Парам02)
Процедура ФункцияФреймворкаПолучитьСохраненноеЗначениеИзКонтекстаСПараметромВозвращает(Парам01,Парам02) Экспорт
    Значение = Ванесса.ПолучитьСохраненноеЗначениеИзКонтекста(Парам01);
    Ванесса.ПроверитьРавенство(Парам02, Значение);
КонецПроцедуры

&НаКлиенте
//И функция фреймворка ПолучитьЗначениеИзКонтекстаЕслиЭтоВозможно с параметром "$тест$" возвращает 1
//@ФункцияФреймворкаПолучитьЗначениеИзКонтекстаЕслиЭтоВозможноСПараметромВозвращает(Парам01,Парам02)
Процедура ФункцияФреймворкаПолучитьЗначениеИзКонтекстаЕслиЭтоВозможноСПараметромВозвращает(Парам01,Парам02) Экспорт
    //Значение = Ванесса.ПолучитьЗначениеИзКонтекстаЕслиЭтоВозможно(Парам01);
    Ванесса.ПроверитьРавенство(Парам02, Парам01);
КонецПроцедуры
