### Описание передачи параметров 

Пути к внутренним файлам задаются относительно каталога tools
Например:
```
   .\JSON\VBParams82OF.json
```

#### Пример json файла для одного Сборки
```
{
   "ИмяСборки":"Сборка 8.2",
   "ВерсияПлатформы":"8.2",
   "КаталогПоискаВерсииПлатформы":"C:\Program Files (x86)\1cv82",
   "СтрокаПодключенияКБазе":"ENTERPRISE /F.\..\Distr\v82ServiceBase /RunModeOrdinaryApplication",
   "ПутьКVanessaAutomation": ".\..\vanessa-automation.epf",
   "КаталогФич": ".\..\features",
   "КаталогиБиблиотек":[
   ".\..\features\Libraries"
   ],
   "EpfДляИнициализацияБазы": ".\epf\init.epf",
   "ПараметрыДляИнициализацияБазы": ".\epf\init.json",
   "ВыполнитьСценарии": "Истина",
   "ДелатьОтчетВФорматеАллюр": "Истина",
   "КаталогOutputAllureБазовый": ".\..\distr\allurereport",
   "ЗавершитьРаботуСистемы": "Истина",
   "ЗакрытьTestClientПослеЗапускаСценариев": "Истина",
   "ДелатьЛогВыполненияСценариевВЖР": "Истина",
   "ДелатьСкриншотПриВозникновенииОшибки": "Истина",
   "КаталогOutputСкриншоты": ".\ServiceBases\ScreenShots",
   "КомандаСделатьСкриншот": '"C:\\Program Files (x86)\\IrfanView\\i_view32.exe" /capture=1 /convert=',
   "ВыгружатьСтатусВыполненияСценариевВФайл": "Истина",
   "ПутьКФайлуДляВыгрузкиСтатусаВыполненияСценариев": ".\..\distr\BuildStatus.log",
   "СоздаватьПодкаталогВКаталогеAllureДляЭтойСборки": "Истина",
   "ДобавлятьКИмениСценарияУсловияВыгрузки": "Истина",
   "СписокТеговИсключение":[
   "IgnoreOnCIMainBuild",
   "IgnoreOn82Builds",
   "IgnoreOnOFBuilds"
   ]
}
```

#### Значения параметров
* ИмяСборки - это имя будет использовано для того, чтобы идентифицировать Сборка среди других в отчете Allure и jUnit. Будет создан каталог, поэтому нельзя использовать запрещенные символы файловой системы.
* ВерсияПлатформы - может быть в краткой форме, например 8.2 или 8.3 и т.д. или в более точной, например 8.3.6 или 8.3.6.1111. Для краткой формы будет взята самая свежая версия платформы.
* КаталогПоискаВерсииПлатформы - каталог, где надо искать версии платформы 1С
* ПутьКVanessaAutomation - путь к vanessa-automation.epf
* СтрокаПодключенияКБазе - Строка подкчлючения к базе
* каталог фич - каталог, откуда будут загружены фичи
* EpfДляИнициализацияБазы - необязательный параметр. Это обработка, которая будет инициализировать БД.
* ПараметрыДляИнициализацияБазы - необязательный параметр. Это json файл, который надо будет прочитать в обработке по инициализации базы.
* ЗапускатьТолстыйКлиент - будет запущен файл 1cv8.exe вместо 1cv8c.exe
* ВыполнитьСценарии - флаг того, что будут выполнены сценарии
* ДелатьОтчетВФорматеАллюр - флаг того, что будут формировться xml файлы для отчета Allurе
* КаталогOutputAllureБазовый - в этом каталоге будут формироваться подкаталоги вида <ИмяСборки>, в которых будут лежать результаты прохождения сценариев в формате xml
* ЗавершитьРаботуСистемы - флаг того, что после выполнения сценариев будет закрыт сеанс 1С, в котором шел запуск сценариев
* ЗакрытьTestClientПослеЗапускаСценариев - закроет сеанс TestClient если он остался незакрытым
* ДелатьЛогВыполненияСценариевВЖР - флаг того, что перед каждым сценарием и шагом будет создана запись в ЖР. Помогает при падении платформы с дампом.
* ВыгружатьСтатусВыполненияСценариевВФайл - флаг, что будет создан файл со статусом всего Сборки. 0 - успешно, 1 - не успешно.
* ПутьКФайлуДляВыгрузкиСтатусаВыполненияСценариев - путь к файлу описанному ранее
* СоздаватьПодкаталогВКаталогеAllureДляЭтойСборки - флаг нужен для варианта отчета Allure, когда все сценарии хранятся не иерархически и когда, например, происходит проверка сценариев на разных версиях платформы
* ДобавлятьКИмениСценарияУсловияВыгрузки - флаг нужен для того, чтобы в финальном отчете можно было отличать сценарии, если мы проверяем их больше чем в одном Сборкае 
* СписокТеговИсключение - массив строк. Если в фиче есть такой тег, то она не будет загружена на выполнение.
* КаталогиБиблиотек - массив строк. Каталоги библиотек.
* ВыводитьСообщенияВФайл - необязательный. Если указан - то будет выводится окно сообщений в файл, указанный в параметре.
* ДелатьСкриншотПриВозникновенииОшибки - флаг того что при возникновении ошибки будут делаться скриншоты
* КаталогOutputСкриншоты - каталог, куда будут делаться скриншоты
* Команда, которая будет выполнятся для снятия скриншота
* КаталогСкриптовСборкиВидео - каталог, где лежат скрипты сборки видео
* СоздаватьИнструкциюВидео - флаг того, что надо делать видео инструкцию
* КаталогOutputИнструкцияВидео - каталог, где окажется записанный видеоролик

