﻿#Использовать v8runner
#Использовать logos

Перем Лог;

Процедура ОчиститьВременныйКаталог(ВременныйКаталог)
	Файлы = НайтиФайлы(ВременныйКаталог,"*",Ложь);
	Для Каждого Файл Из Файлы Цикл
		УдалитьФайлы(Файл.ПолноеИмя);
	КонецЦикла;	
КонецПроцедуры

Процедура ОбработатьФайлConfiguration_xml(ИмяФайла)
	ИмяВременногоФайла = ПолучитьИмяВременногоФайла("xml");
	
	Текст = Новый ЧтениеТекста;
	Текст.Открыть(ИмяФайла,"UTF-8");
	
	ЗТ = Новый ЗаписьТекста(ИмяВременногоФайла,"UTF-8",,Ложь); 
	
	ЗначениеВерсия = "Version8_3_14";
	
	Пока Истина Цикл
		Стр = Текст.ПрочитатьСтроку();
		Если Стр = Неопределено Тогда
			Прервать;
		КонецЕсли;	 
		
		Если Найти(Стр,"<CompatibilityMode>") > 0 Тогда
			Стр = "			<CompatibilityMode>" + ЗначениеВерсия + "</CompatibilityMode>";
		КонецЕсли;	 
		
		ЗТ.ЗаписатьСтроку(Стр); 
	КонецЦикла;	
	
	Текст.Закрыть();
	ЗТ.Закрыть();
	
	КопироватьФайл(ИмяВременногоФайла,ИмяФайла);
	УдалитьФайлы(ИмяВременногоФайла);
КонецПроцедуры

Функция ПолучитьВременныйКаталог()
	ИмяФайла = ПолучитьИмяВременногоФайла();
	СоздатьКаталог(ИмяФайла);
	Возврат ИмяФайла;
КонецФункции	

Лог = Логирование.ПолучитьЛог("behavior.build.log");

массивСервисныхБаз = Новый Массив();

массивСервисныхБаз.Добавить(Новый Структура("ПутьКИсходникам,СоздаваемаяБаза",
	"../../lib/CF/83/","../ServiceBases/v83ServiceBaseLinux"));

массивСервисныхБаз.Добавить(Новый Структура("ПутьКИсходникам,СоздаваемаяБаза",
	"../../lib/CF/83NoSync/","../ServiceBases/v83ServiceBaseNoSyncLinux"));

КаталогПлатформы = "/opt/1C/v8.3/x86_64";

Для каждого _конфигурация из массивСервисныхБаз Цикл
	
	Лог.Информация("Обрабатываю исходные файлы " + _конфигурация.ПутьКИсходникам);
	указательНаБазу = Новый Файл(_конфигурация.СоздаваемаяБаза + "/1Cv8.1cd");
	//Сообщить(указательНаБазу.ПолноеИмя);
	КаталогБазы = указательНаБазу.путь;
	ФайлКаталогБазы = Новый Файл(КаталогБазы);

	Если ФайлКаталогБазы.Существует() и указательНаБазу.Существует() Тогда
		лог.Отладка("Ранее был создан каталог " + _конфигурация.СоздаваемаяБаза);
	Иначе
		лог.Отладка("Создание сервисной базы контрибьютора " + _конфигурация.СоздаваемаяБаза);
		СтрокаКоманды = КаталогПлатформы + "/1cv8 CREATEINFOBASE File=%1;";
		СтрокаКоманды = СтрЗаменить(СтрокаКоманды,"%1",_конфигурация.СоздаваемаяБаза);
		Сообщить("СтрокаКоманды="+СтрокаКоманды);
		
		Если НЕ ФайлКаталогБазы.Существует() Тогда
			СоздатьКаталог(ФайлКаталогБазы.ПолноеИмя);
		КонецЕсли;	 
		
		retCode = -1;
		ЗапуститьПриложение(СтрокаКоманды,,Истина,retCode);
		Сообщить("retCode="+retCode);
		Если retCode <> 0 Тогда
			ВызватьИсключение "Не получилось создать базу: " + _конфигурация.СоздаваемаяБаза;
		КонецЕсли;	 
	КонецЕсли;	
	
	
	//загрузка конфигурации из файлов
	СтрокаКоманды = КаталогПлатформы + "/1cv8 DESIGNER /F%1 /LoadConfigFromFiles ""%2"" /UpdateDBCfg ";
	СтрокаКоманды = СтрЗаменить(СтрокаКоманды,"%1",_конфигурация.СоздаваемаяБаза);
	СтрокаКоманды = СтрЗаменить(СтрокаКоманды,"%2",_конфигурация.ПутьКИсходникам);
	Сообщить("СтрокаКоманды="+СтрокаКоманды);
	retCode = -1;
	ЗапуститьПриложение(СтрокаКоманды,,Истина,retCode);
	Сообщить("retCode="+retCode);
	Если retCode <> 0 Тогда
		ВызватьИсключение "Не получилось загрузить конфигурацию из файлов: " + _конфигурация.СоздаваемаяБаза;
	КонецЕсли;	 
	
	//теперь выгрузим конфигурацию в файлы ещё раз и заменим параметр CompatibilityMode на DontUse, чтобы гарантировать, что не используется режим совместимости
	ВременныйКаталог = ПолучитьВременныйКаталог();
	
	СтрокаКоманды = КаталогПлатформы + "/1cv8 DESIGNER /F%1 /DumpConfigToFiles ""%2"" ";
	СтрокаКоманды = СтрЗаменить(СтрокаКоманды,"%1",_конфигурация.СоздаваемаяБаза);
	СтрокаКоманды = СтрЗаменить(СтрокаКоманды,"%2",ВременныйКаталог);
	Сообщить("СтрокаКоманды="+СтрокаКоманды);
	
	retCode = -1;
	ЗапуститьПриложение(СтрокаКоманды,,Истина,retCode);
	Сообщить("retCode="+retCode);
	Если retCode <> 0 Тогда
		ВызватьИсключение "Не получилось выгрузить конфигурацию во временный каталог: " + _конфигурация.СоздаваемаяБаза;
	КонецЕсли;	
	
	ОбработатьФайлConfiguration_xml(ВременныйКаталог + "/Configuration.xml");
	
	//теперь загрузим конфигурацию обратно
	СтрокаКоманды = КаталогПлатформы + "/1cv8 DESIGNER /F%1 /LoadConfigFromFiles ""%2"" /UpdateDBCfg ";
	СтрокаКоманды = СтрЗаменить(СтрокаКоманды,"%1",_конфигурация.СоздаваемаяБаза);
	СтрокаКоманды = СтрЗаменить(СтрокаКоманды,"%2",ВременныйКаталог);
	Сообщить("СтрокаКоманды="+СтрокаКоманды);
	retCode = -1;
	ЗапуститьПриложение(СтрокаКоманды,,Истина,retCode);
	Сообщить("retCode="+retCode);
	Если retCode <> 0 Тогда
		ВызватьИсключение "Не получилось загрузить конфигурацию из файлов: " + _конфигурация.СоздаваемаяБаза;
	КонецЕсли;	 
	
	ОчиститьВременныйКаталог(ВременныйКаталог);
	УдалитьФайлы(ВременныйКаталог);
КонецЦикла;
